# WebSocket Measurement Framework #
---------------

*WebSocket Measurement Framework* is an open source measurement framework developed by zafaco GmbH. It consists of a measurement client (*wsClient*, JavaScript) and a measurement server (*wsServer*, C++).

zafaco GmbH: <http://www.zafaco.de>, <info@zafaco.de>

The *WebSocket Measurement Framework* is used for the measurement of round-trip time (RTT) as well as download and upload bit rates between two measuring endpoints, i.e. a measurement client and a measurement server, where the measurements must be initialized by the measurement client.

For RTT measurements, WebSocket Ping and Pong control frames are utilised. Download as well as upload measurements are utilising WebSocket Data Frames. The measured bit rates are stated as bits per second for TCP Payload Throughput, taking the overhead of WebSocket framing into account.

The measurement server must be deployed on a Linux-based Operating System (see wsServer/README.md), whereas the measurement client can be deployed on a Web Server of your choice (see wsClient/README.md). The measurement client can be used with various browsers which support the WebSocket protocol Version 13 (RFC 6455, <https://tools.ietf.org/html/rfc6455>).

---------------

## License ##

*WebSocket Measurement Framework* is released under the AGPLv3 <https://www.gnu.org/licenses/agpl-3.0.txt>

Copyright (C) 2016-2017 zafaco GmbH

This program is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

---------------

## Required Dependencies ##

### Nopoll: a websocket toolkit ###

Available at: <https://github.com/ASPLes/nopoll>

Customized Version available at: <https://github.com/zafaco/nopoll>

License: LGPLv2.1 <https://github.com/ASPLes/nopoll/blob/master/COPYING>

Copyright (C) 2017 Advanced Software Production Line, S.L.
Copyright (C) 2017 zafaco GmbH (Customization: nopoll_conn.c, Lines 3322 and 3323: Do not unref on received PONG frame)

This program is free software; you can redistribute it and/or   modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU General Public License   along with this program. If not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 , USA, or see <http://www.gnu.org/licenses/>.


### json11: A tiny JSON library for C++11 ###

Available at: <https://github.com/dropbox/json11>

- Bundled as:
	- "wsServer/src/json11.hpp"
	- "wsServer/src/json11.cpp"
	
License: MIT <https://github.com/dropbox/json11/blob/master/LICENSE.txt>

Copyright (c) 2013 Dropbox, Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

---------------

## Installation Instructions ##

1. Compile and Run *wsServer*  (see wsServer/README.md)
2. Configure and Deploy *wsClient* (see wsClient/README.md)
3. Navigate to http://myWebServer/wsClient/index.html