# wsServer #
---------------

*wsServer* is the Server component of zafaco's WebSocket Measurement Framework

zafaco GmbH: <http://www.zafaco.de>, <info@zafaco.de>

---------------

## License ##

*wsServer* is released under the AGPLv3 <https://www.gnu.org/licenses/agpl-3.0.txt>

Copyright (C) 2016-2017 zafaco GmbH

This program is free software: you can redistribute it and/or modify it under the terms of the GNU Affero General Public License version 3 as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.

---------------

## Required Dependencies ##

### Nopoll: a websocket toolkit ###

Available at: <https://github.com/ASPLes/nopoll>

Customized Version available at: <https://github.com/zafaco/nopoll>

License: LGPLv2.1 <https://github.com/ASPLes/nopoll/blob/master/COPYING>

Copyright (C) 2017 Advanced Software Production Line, S.L.
Copyright (C) 2017 zafaco GmbH (Customization: nopoll_conn.c, Lines 3322 and 3323: Do not unref on received PONG frame)

This program is free software; you can redistribute it and/or   modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU General Public License   along with this program. If not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 , USA, or see <http://www.gnu.org/licenses/>.


### json11: A tiny JSON library for C++11 ###

Available at: <https://github.com/dropbox/json11>

- Bundled as:
	- "wsServer/src/json11.hpp"
	- "wsServer/src/json11.cpp"
	
License: MIT <https://github.com/dropbox/json11/blob/master/LICENSE.txt>

Copyright (c) 2013 Dropbox, Inc.

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

---------------

## Installation Dependencies ##

*wsServer* is designed for Linux-based Operating Systems (x32, x64, tested on Ubuntu 14.04 and 16.04) and requires *make* as well as *cmake*

---------------

## Installation Instructions ##

1. Compile and Deploy Customized Version of *Nopoll*
2. Run "cmake ." in directory wsServer/
3. Run "make" in directory wsServer/
4. Run "wsServer" in directory wsServer/build
5. Run "wsServer -h" for command line options