/*!   
    \file connection.cpp
    \brief TCP6 Socket Wrapper
    \author zafaco GmbH <info@zafaco.de>
    \date Last update: 2017-07-19

    Copyright (C) 2016 - 2017 zafaco GmbH

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License version 3 
    as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "connection.h"


CConnection::CConnection()
{
    sock = 0;
}

CConnection::~CConnection()
{
}

int CConnection::tcp6SocketServer( int &nPort )
{
    int on = 1;
    int no = 0;

    sock = socket( AF_INET6, SOCK_STREAM, 0 );
    if( sock == -1 )
    {
            TRC_ERR("Error [tcp6SocketServer]: Could not creating socket" );
            return EXIT_FAILURE;
    }
    
    memset(&sockinfo_in6, 0, sizeof(sockinfo_in6));
    sockinfo_in6.sin6_flowinfo 	= 0;
    sockinfo_in6.sin6_family 	= AF_INET6;
    sockinfo_in6.sin6_port  = htons(nPort);

    setsockopt(sock, IPPROTO_IPV6, IPV6_V6ONLY, (char*)&no, sizeof(no));

    setsockopt(sock, SOL_SOCKET,SO_REUSEADDR,(const char *) &on, sizeof(on));

    if( bind( sock, (struct sockaddr*)&sockinfo_in6, sizeof(sockinfo_in6)) == -1 )
    {
            TRC_ERR("Error [tcp6SocketServer]: Could not bind socket to interface" );
            return EXIT_FAILURE;
    }

    listen(sock, 1);

    return sock;
}