/*!   
    \file header.h
    \brief WebSocket Measurement Server header File
    \author zafaco GmbH <info@zafaco.de>
    \date Last update: 2017-07-19

    Copyright (C) 2016 - 2017 zafaco GmbH

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License version 3 
    as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef HEADER_H
#define HEADER_H


#include <sys/socket.h>
#include <sys/types.h>
#include <sys/syscall.h>
#include <cstdlib>
#include <iostream>
#include <unistd.h>
#include <fstream>
#include <signal.h>
#include <thread>
#include <vector>
#include <cmath>
#include <strings.h>
#include <algorithm>
#include <stdio.h>
#include <string.h>
#include <netinet/tcp.h>
#include <netpacket/packet.h>
#include <arpa/inet.h>


#include "nopoll.h"
#include "nopoll_ctx.h"
#include "nopoll_conn.h"
#include "nopoll_msg.h"
#include "nopoll_listener.h"
#include "nopoll_private.h"


#include "basisthread.h"
#include "tool.h"
#include "connection.h"
#include "json11.hpp"
#include "wshandler.h"


using namespace std;


#define MAX_PACKET_SIZE 1440
#define MAXBUFFER 1580

#define TRC_DEBUG(s)  cout << "DEBUG: " << s << endl;
#define TRC_INFO(s)   cout << "INFO: " << s << endl;
#define TRC_WARN(s)   cout << "WARN: " << s << endl;
#define TRC_ERR(s)    cout << "ERR: " << s << endl;
#define TRC_CRIT(s)   cout << "CRIT: " << s << endl;


extern bool DEBUG;
extern bool DEBUG_NOPOLL;
extern bool DEBUG_NOPOLL_ERROR;
extern bool DEBUG_NOPOLL_CRITICAL;
extern bool RUNNING;

#endif