/*!   
    \file tool.h
    \brief Tool class
    \author zafaco GmbH <info@zafaco.de>
    \date Last update: 2017-07-19

    Copyright (C) 2016 - 2017 zafaco GmbH

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License version 3 
    as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef TOOL_H
#define TOOL_H


#include "header.h"


using namespace std;

class CTool
{
    public:
        CTool();

        virtual ~CTool();

        static string get_timestamp_string();
        
        static void toLower(string &sText);
        
        static string get_ip_str(const struct sockaddr *sa);
        
        static string getHostname();
        
        static void replaceStringInPlace(string& subject, const string& search, const string& replace);
        
        static void tokenize(string &str,vector<string> &tokens, string &delimiters);
        
        static unsigned long long get_timestamp();
        
        static int randomData();
        
        static int randomData(vector<char> &vVector, int size);
        
        static int randomData(char *sbuffer, int size);
        
        static int get_timestamp_usec();
        
        static int get_timestamp_sec();
};

#endif


