/*!   
    \file wshandler.h
    \brief WebSocket handler
    \author zafaco GmbH <info@zafaco.de>
    \date Last update: 2017-11-28

    Copyright (C) 2016 - 2017 zafaco GmbH

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License version 3 
    as published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef WSHANDLER_H
#define WSHANDLER_H


#include "header.h"


class CWsHandler
{
    public:
        CWsHandler();

        virtual ~CWsHandler();

        CWsHandler(sockaddr_in6 *pClient, int nSocket, string nClientIp);
        
        int handle_websocket();

        static int websocket_open_handler              (noPollCtx *ctx, noPollConn *conn, noPollPtr user_data);
        static int websocket_ready_handler             (noPollCtx *ctx, noPollConn *conn, noPollPtr user_data);
        static void websocket_message_handler          (noPollCtx *ctx, noPollConn *conn, noPollMsg *msg, noPollPtr user_data);
        static void websocket_close_handler            (noPollCtx *ctx, noPollConn *conn, noPollPtr user_data);
        static void websocket_timeout_handler          (noPollCtx *ctx, noPollConn *conn);
        static void nopoll_logging_handler             (noPollCtx * ctx, noPollDebugLevel level, const char * log_msg, noPollPtr user_data);
    
        static int roundTripTime                       (noPollCtx *ctx, noPollConn *conn);
        static void setRoundTripTimeKPIs               ();
        static void sendRoundTripTimeResponse          (noPollCtx *ctx, noPollConn *conn);
        static int download                            (noPollCtx *ctx, noPollConn *conn);
        static int upload                              (noPollCtx *ctx, noPollConn *conn);
        static unsigned long long formatCurrentTime    (unsigned long long endTime, unsigned long long currentTime);
};

#endif